VERSION 2.00
Begin Form BaumGrafik 
   Caption         =   "Statischer Baum: Grafik"
   ClientHeight    =   3990
   ClientLeft      =   480
   ClientTop       =   1500
   ClientWidth     =   7095
   Height          =   4395
   Icon            =   BAUM1.FRX:0000
   Left            =   420
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   7095
   Top             =   1155
   Width           =   7215
   Begin PictureBox Pic 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "Times New Roman"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   3735
      Left            =   0
      ScaleHeight     =   3705
      ScaleWidth      =   6825
      TabIndex        =   2
      Top             =   0
      Width           =   6855
   End
   Begin HScrollBar HScroll1 
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3720
      Width           =   6855
   End
   Begin VScrollBar VScroll1 
      Height          =   3735
      Left            =   6840
      Min             =   1
      TabIndex        =   0
      Top             =   0
      Value           =   1
      Width           =   255
   End
End

Dim treffer_x As Single, treffer_y As Single

Sub Form_Paint ()

maus 0

Pic.Cls
For ebene% = 1 To ebene_anz%
   yy = y(ebene%)
   xx = x(100)
   For fkt% = 1 To Baum.ProcListe.ListCount
      If Baum.EbenenListe.ItemData(fkt% - 1) = ebene% Then
         zeichne_eintrag ebene%, fkt%, xx, yy, 0
      End If
   Next
Next

maus 1

End Sub

Sub Form_Resize ()

Pic.Width = ScaleWidth - 255
Pic.Height = ScaleHeight - 255
HScroll1.Width = ScaleWidth - 255
HScroll1.Top = ScaleHeight - 255
VScroll1.Left = ScaleWidth - 255
VScroll1.Height = ScaleHeight - 255

End Sub

Sub HScroll1_Change ()

Form_Paint

End Sub

Sub pfeil (vonebene%, vonx, nachebene%, nachx, h)

xs# = Pic.CurrentX
ys# = Pic.CurrentY

If vonebene% < nachebene% Then
   pfeil_zeichne x(vonx), y(vonebene%) + h, x(nachx), y(nachebene%) - h
ElseIf vonebene% > nachebene% Then
   pfeil_zeichne x(vonx), y(vonebene%) - h, x(nachx), y(nachebene%) + h
ElseIf vonx <> nachx Then
   pfeil_zeichne x(vonx), y(vonebene%), x(nachx), y(nachebene%)
Else
   Pic.Circle (x(vonx), y(vonebene%) + h / 2), 200
End If

Pic.CurrentX = xs#
Pic.CurrentY = ys#

End Sub

Sub pfeil_zeichne (x1, y1, x2, y2)

l = 100   'Pfeilspitzenlnge
a = 20    'Pfeilwinkel

Pic.Line (x1, y1)-(x2, y2)

pi = 3.141592654

If x1 = x2 Then
   If y2 > y1 Then b = pi / 2 Else b = -pi / 2
Else
   b = Atn((y2 - y1) / (x2 - x1))
   If x2 < x1 Then b = b + pi
End If

a = a * pi / 180
Pic.Line (x2, y2)-(x2 - l * Cos(a + b), y2 - l * Sin(a + b))
Pic.Line (x2, y2)-(x2 - l * Cos(-a + b), y2 - l * Sin(-a + b))

End Sub

Sub Pic_MouseDown (Button As Integer, Shift As Integer, x1 As Single, y1 As Single)

maus 0

fa% = 1
treffer_x = x1
treffer_y = y1

For ebene% = 1 To ebene_anz%
   yy = y(ebene%)
   xx = x(100)
   For fkt% = 1 To Baum.ProcListe.ListCount
      If Baum.EbenenListe.ItemData(fkt% - 1) = ebene% Then
         zeichne_eintrag ebene%, fkt%, xx, yy, fa%
      End If
   Next
Next

maus 1

End Sub

Sub VScroll1_Change ()

Form_Paint

End Sub

Function x (xx)

x = xx - HScroll1.Value * Val(HScroll1.Tag)

End Function

Function y (yy%)

y = 2000 * (yy% - VScroll1.Value) + 200

End Function

Sub zeichne_eintrag (ebene%, fkt%, xx, yy, fa%)

'Bestimme Bezeichnung
a$ = Baum.ProcListe.List(fkt% - 1)
If InStr(a$, ".") Then e$ = zeichennext$(a$, ".") Else e$ = ""
If Pic.TextWidth(a$) > Pic.TextWidth(e$) Then dx = Pic.TextWidth(a$) Else dx = Pic.TextWidth(e$)

'Farbe bestimmen
If fa% = 1 And treffer_y >= (y(ebene% - 1) + y(ebene%)) / 2 And treffer_y <= (y(ebene%) + y(ebene% + 1)) / 2 And treffer_x < xx + dx + Pic.TextWidth("      ") And f% = 0 Then
   Pic.ForeColor = RGB(255, 0, 0)
   fa% = 0
Else
   Pic.ForeColor = RGB(0, 0, 0)
End If

'Zeichne Bezeichnung
If xx + Pic.TextWidth(a$) > 0 And xx < Pic.ScaleWidth And yy > 0 And yy < Pic.ScaleHeight Then
  Pic.CurrentX = xx: Pic.CurrentY = yy: Pic.Print a$;
  Pic.CurrentX = xx: Pic.CurrentY = yy - 160: Pic.Print e$;
End If

'Zeichne Pfeile
w$ = Baum.EbenenListe.List(fkt% - 1)
xm = xx + Pic.TextWidth(a$) / 2 - x(0)
h = Pic.TextHeight(a$)
Do While Len(w$)
   nach% = Val(zeichennext$(w$, ";"))
   ebene2% = Baum.EbenenListe.ItemData(nach% - 1)
   x2 = Val(Baum.XPosTabelle.List(nach% - 1))
   pfeil ebene%, xm, ebene2%, x2, h
Loop

xx = xx + dx + Pic.TextWidth("            ")

End Sub

